Subject: Re: linux-next: build failure after merge of the pwm tree

From: Michal Wilczynski <[email-masked]>
Date: Mon, 27 Oct 2025 09:36:32 +0100

On 10/27/25 02:51, Stephen Rothwell wrote:
> Hi all,
> 
> After merging the pwm tree, today's linux-next build (x86_64 allmodconfig)
> failed like this:
> 
> error[E0277]: the trait bound `core::result::Result<core::pin::Pin<Box<Th1520PwmPlatformDriver, Kmalloc>>, kernel::error::Error>: PinInit<Th1520PwmPlatformDriver, kernel::error::Error>` is not satisfied
>    --> drivers/pwm/pwm_th1520.rs:331:10
>     |
> 331 |     ) -> Result<Pin<KBox<Self>>> {
>     |          ^^^^^^^^^^^^^^^^^^^^^^^ unsatisfied trait bound
>     |
>     = help: the trait `PinInit<Th1520PwmPlatformDriver, kernel::error::Error>` is not implemented for `Result<Pin<Box<Th1520PwmPlatformDriver, Kmalloc>>, Error>`
>             but trait `PinInit<core::pin::Pin<Box<Th1520PwmPlatformDriver, Kmalloc>>, kernel::error::Error>` is implemented for it
>     = help: for that trait implementation, expected `core::pin::Pin<Box<Th1520PwmPlatformDriver, Kmalloc>>`, found `Th1520PwmPlatformDriver`
> note: required by a bound in `kernel::platform::Driver::{synthetic#0}`
>    --> rust/kernel/platform.rs:196:15
>     |
> 196 |     ) -> impl PinInit<Self, Error>;
>     |               ^^^^^^^^^^^^^^^^^^^^ required by this bound in `Driver::{synthetic#0}`
> 
> error: aborting due to 1 previous error
> 
> For more information about this error, try `rustc --explain E0277`.
> 
> Caused by commit
> 
>   fb3957af9ec6 ("pwm: Add Rust driver for T-HEAD TH1520 SoC")
> 
> presumably interacting with something merged earlier in my tree.
> If someone could provide me with an appropriate merge resolution, I will
> apply it.
> 
> I have used the pwm tree from next-20251024 for today.
> 

Hi,
I believe this would fix the problem:
diff --git a/drivers/pwm/pwm_th1520.rs b/drivers/pwm/pwm_th1520.rs
index 0ad38b78be85..dd554574adc8 100644
--- a/drivers/pwm/pwm_th1520.rs
+++ b/drivers/pwm/pwm_th1520.rs
@@ -328,7 +328,7 @@ impl platform::Driver for Th1520PwmPlatformDriver {
     fn probe(
         pdev: &platform::Device<Core>,
         _id_info: Option<&Self::IdInfo>,
-    ) -> Result<Pin<KBox<Self>>> {
+    ) -> impl PinInit<Self, Error> {
         let dev = pdev.as_ref();
         let request = pdev.io_request_by_index(0).ok_or(ENODEV)?;
 
@@ -365,7 +365,7 @@ fn probe(
 
         pwm::Registration::register(dev, chip)?;
 
-        Ok(KBox::new(Th1520PwmPlatformDriver, GFP_KERNEL)?.into())
+        Ok(Th1520PwmPlatformDriver)
     }
 }

This is caused by change in fn probe, caused by this commit [1].

[1] - https://lore.kernel.org/all/[email-masked]/

Best regards,
-- 
Michal Wilczynski <[email-masked]>